// simpleList.h          July 14, 1995


#ifndef SIMPLE_LIST_H
#define SIMPLE_LIST_H


class simpleListEntry {
//    ===============
  public:
    simpleListEntry* _next;
};


class simpleList {
//    ==========
  protected:
    int _list_length;
    simpleListEntry* _first;
    simpleListEntry* _last;
  public:
    int listLength() { return _list_length; }
    simpleList() { _list_length = 0; _first = _last = 0; }
    //
    simpleListEntry* succ( simpleListEntry* p ) 
    /*               ==== */   { if (p) return p->_next; else return _first; }
    void append( simpleListEntry* );  // append at the end of the list
    //   ======
    void insert( simpleListEntry* p, simpleListEntry* atp =0 );  
    //   ======                       //  insert *p after *atp
                                      // if atp=0, insert at head of list
};


/* example:

   class myListEntry: public simpleListEntry {
       ...
   };


   class myList: public simpleList {
       ...
   };

*/

//////////////////////////////////////////////////////////////////////////////


class simpleStringListEntry: public simpleListEntry {
//    =====================
  public:
    const char* strngp; 
};


class simpleStringList: public simpleList {
//    ================
//    lexicographically ordered
  public:
     simpleStringList() {;}
     //
     enum retrieveStatus { no_match, is_prefix, exact_match }; 
     //
     simpleStringListEntry* retrieve( const char*, int* statusp ); 
     //                     ======== 
     /*          If the search string is found in the list, 
                 the corresponding list element is returned and *statusp 
                 returns "exact_match". 
                 If the search string is only a prefix to some string 
                 in the list, the list element BEFORE that containing the 
                 matching string (i.e., the list element whose string 
                 immediately preceeds the search string) is returned and 
                 *statusp returns "is_prefix". 
                 If the search string is not a prefix to any string in the 
                 list, the list element whose string immediately preceeds 
                 the search string (in lexicographic order) is returned 
                 and *statusp returns "no_match". 
     */
};


#endif
